
\section{Monitoring}
\label{sec:Monitoring}

This module implements a Root histogram manager and some simple fonctions to
easily implement the histogramming of variables ``on the fly'' in the code.

\section{Initialisation}

An histogram manager has to be implemented at the top level OR in each source
file by including the following lines:
\begin{lstlisting}
#include "HistogramManager.h"
\end{lstlisting}

\begin{lstlisting}
// Debug Histograms
static HistogramManager * AHM = NULL;
\end{lstlisting}
before the code starts.

At the beginnig (initialisation call): 
\begin{lstlisting}
// ArborMonitoring
AHM = new HistogramManager("Monitoring.root");
\end{lstlisting}
and the end:
\begin{lstlisting}
    // Moniroting
    AHM->Write();
\end{lstlisting}

If a reset function is be implemented, it should include this one: 
\begin{lstlisting}
// to be added to the clearing or ressetting function. 
AHM->Reset();
\end{lstlisting}

\subsection{Histogram Creation and Filling}

The basic call to create (if not yet existing) and filling a TH1F histogram is

\begin{lstlisting}
    AHM->CreateFill("histName", MyVariable, nxBins, xMin, xMax);
\end{lstlisting}

(once created the last 3 parameters are ignored).
A TH2F version is implemented:
\begin{lstlisting}
    AHM->CreateFill("histName", xVar, yVar, nxBins, xMin, xMax, nyBins, yMin, yMax);
\end{lstlisting}

This version will create fixed range and binning histograms.
For variables of unknown span, the user might call:
\begin{lstlisting}
    AHM->CreateFillFlex("histName", MyVariable, nxBins, xMin, xMax);
\end{lstlisting}
(note that this might be unsuitable to produce efficiency plots for which
numerator and denominator histograms must share the same range and binning)

\subsection{Code integration}

To ease the debugging and code integration a hierarchy of directories is
automatically generated if the histogram name includes one, e.g. as :
\begin{lstlisting}
    AHM->CreateFill("dir1/dir2/histName", MyVariable, nxBins, xMin, xMax);
\end{lstlisting}

A simple way to keep per function histograms is to use the pre-compiler macro
\verb:__func__: and stl string concatanation, as in those two examples:
\begin{lstlisting}
    AHM->CreateFillFlex(string(__func__)+"/hNinputHits", inputHits.size(), 200, -0.5, 200-0.
    AHM->CreateFillFlex(string(__func__)+to_string(time)+"/hWeightedDist", dist, 100, -0.5, 300-0.5);
\end{lstlisting}
where \verb:time: is an integer increasing with the number of calls.

The Clustering/Arbor3.cc code with many examples implemented results in the
following structure:
\begin{figure}[H]
  \centering
  \includegraphics[width=\textwidth]{Monitoring_root.png}
  \caption{File structure generated for the calls in Arbor3.cc}
  \label{fig:Monitoring.root}
\end{figure}

You are done: happy monitoring!

\subsection{Caveats:}

For now on, a full singleton mechanism is not yet implemented, which means that
\begin{itemize}
\item one instance of the Histogram Manager (HM) has to be manually implemented
  in each independant source file
\item one root file per source file has to be called, with a different name
\end{itemize}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../../../Docs/Manual.tex"
%%% fill-column: 80
%%% End:
